=== debian/changelog ===
opentelemetry-cpp (1.17.0-3ubuntu1) plucky; urgency=medium

  * Disable additional tests to avoid FTBFS on amd64 and ppc64el

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 13 Dec 2024 12:30:02 +0000

opentelemetry-cpp (1.17.0-3) unstable; urgency=low

  * Correct VCS links
  * Declare compliance with Standards-Version 4.7.0.1
  * Correct DEP-5 syntax for MIT License

 -- Santiago Ruano Rincón <santiago@freexian.com>  Wed, 06 Nov 2024 23:41:37 -0300

opentelemetry-cpp (1.17.0-2) unstable; urgency=low

  * Relax the tests allowing them to fail in some architectures
  * Disable more tests that commonly fail in all the architectures
  * Add patch to improve how to handle the yield instruction in ARM
  * Wrap and sort -ast
  * Enable ARM builds and wrap-and-sort test on Salsa CI

 -- Santiago Ruano Rincón <santiago@freexian.com>  Wed, 06 Nov 2024 15:01:40 -0300

opentelemetry-cpp (1.17.0-1) unstable; urgency=low

  * Upload to unstable

 -- Santiago Ruano Rincón <santiago@freexian.com>  Tue, 05 Nov 2024 12:09:18 -0300

opentelemetry-cpp (1.17.0-1~exp2) experimental; urgency=medium

  * Fix copyright statement for ETW exporters. Thanks to Thorsten Alteholz.
  * Add debian/gbp.conf to set the default debian branch

 -- Santiago Ruano Rincón <santiago@freexian.com>  Fri, 18 Oct 2024 14:34:04 -0300

opentelemetry-cpp (1.17.0-1~exp1) experimental; urgency=medium

  * Initial release. (Closes: #1074242)

 -- Santiago Ruano Rincón <santiago@freexian.com>  Thu, 17 Oct 2024 23:01:10 -0300
